$include "rapidq2.inc"
$include "rapidq.inc"
$include "SIS-constants.bas"

dim ver$ as string
ver$="3.4.0"
'3.3.0: change 1-1) , 2-1) structure, formatted muber (1000000 --> 1.000.000)
'3.4.0: add button to open extraction folder

' Linux support completed since v. 3.1.1 by recreating GZIPped files
' from raw ZLIB streams; this is accomplished by prepending a standard
' ZLIB header, and appending a fake CRC32 and the original file size, to
' any ZLIB stream extracted from the SIS file; the resulting byte stream
' is saved as .gz file, which can be managed with standard GZIP program.


' ************ ZLIB section (comment out if compiling for Linux)  ***********
Private Declare Function compress Lib "zlib.dll" alias "compress"  (byref  dest as string, byref  destLen as long, byref  src as string,   srcLen as long ) As Long
Private Declare Function uncompress Lib "zlib.dll" alias "uncompress" (byref  dest as string, byref  destLen as long, byref  src as string,   srcLen as long) As Long
  dim CompressedString as string
  dim CompressedBuffer_Size as long
  dim ToBeCompressedString as string
  dim ToBeCompressedString_Size as long
  dim sUncompressedString as string
  dim UncompressedString_size as long
' **************************************************************************

declare sub ChooseSISFile
declare sub UpdateGUI
declare sub FileRead
declare sub ExtractButtonClicked
declare sub GetFileName
declare sub RunFile
declare function SetupFileName() as string
declare sub ShowHelp
declare sub OpenExtractionFolder

dim DEBUGPATH2 as string
dim LENFILERECORD as byte
dim SAVEDIR as string
dim SISFileName as string
dim PROGDIR$ as string
dim SavedFile(1000) as string
dim extension as string
dim extracted as long
dim conta_saved as long

LENFILERECORD = 28

$IFDEF WIN32
   const SLASH = "\"
$ELSE
   const SLASH = "/"
$ENDIF
$DEFINE MAX_PATH 260

DEBUGPATH2 =  "f:\documenti\rapidq\SIS" ' "c:\downloads"
SAVEDIR = curdir$+SLASH

$include "SISRead-gui.bas"
ExtractButton.enabled = 0
OpenFolderButton.enabled = 0
PROGDIR$=curdir$
form.showmodal

sub Init
conta  = 0
trovato  = 0
SISversion  = 0
NumLang  = 0
PointLang  = 0
x  = 0
NumFiles  = 0
PointFiles  = 0
NameLength  = 0
PointAppName  = 0
LenAppName  = 0
PointAppNameActual  = 0
PointCapab  = 0
Value  = 0
ModelUID  = 0
FileTypeAlt  = 0
FileRecordType  = 0
LanguageOffset  = 0
AppNameLength  = 0
AppNamePointer  = 0
ComponentNameBeginning  = 0
ExtractedFileName  = ""
ExtractedFileLength  = 0
ExtractedFilePointer  = 0
RecLen  = 0
LocalNumLang  = 0
Compressed  = 0
OriginalFileSize  = 0
UncompressResult  = 0
CurrentLang  = 0
temp  = 0
FilesList.clear
end sub

function SetupFileName() as string
	dim tempfilename as string
'	dim extension as string
  	TempFileName = ExtractedFileNameFull
  	TempFileName = replacesubstr$(TempFileName,SLASH,"#") ' Replace SLASHES with #.
  	TempFileName = right$(TempFileName,len(ExtractedFileNameFull)-2) ' Cut drive letter and ":" character.
  	' Extension will be moved to the end of the file, after lanuage description:
  	if rinstr(TempFileName,".")>0 then
			extension = mid$(TempFileName,rinstr(TempFileName,"."),len(TempFileName)-rinstr(TempFileName,".")) + extension

		end if
  	TempFileName = left$(TempFileName,len(TempFileName)-5) & Extension & "(" & lingua(CurrentLang) & ")" & Extension
  	SetupFileName = TempFileName
end function

sub RunFile ' In Windows OS, double clicking on filename displays it.
dim CLI as string
dim tempdir as string
	if extracted = 0 then
		showmessage("You must extract files before!")
		exit sub
	end if
	OpenFolderButton.enabled = 1
  tempdir = curdir$
  chdir(progdir$+SLASH+Appname)
	CLI = SavedFile(fileslist.itemindex)
  run  "START " + chr$(34) + CLI + chr$(34)
  chdir(tempdir)
end sub

sub OpenExtractionFolder
	  run  "START "+ chr$(34)  + SAVEDIR + AppName + chr$(34)
end sub

function zero$(s as string) as string
	if len(s)=1 then zero$="0"+s else zero$=s
end function

sub GetFileName
dim tempdebug as string
							SISFile.seek(PointFiles+20,0)
			   			SISfile.read(L)
'                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Nome file lungo "+str$(L)+" caratteri.")
			   			NameLength = L
 			   			SISFile.seek(PointFiles+24,0)
			   			SISfile.read(L)
'                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Nome inizia a offset: "+str$(L)+ " ("+hex$(L)+") (scritto in "+str$(PointFiles+24)+")")
 			   			SISFile.seek(L,0)
 			   			ExtractedFileNameFull = replacesubstr$(SISfile.readstr(NameLength),chr$(0),"")
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Nome = '"+ ExtractedFileName +"'")
 			   			ExtractedFileName = mid$(ExtractedFileNameFull,RInstr(ExtractedFileNameFull,SLASH)+1,len(ExtractedFileNameFull)-RInstr(ExtractedFileNameFull,SLASH))
end sub

sub UpdateGUI
		FilesList.clear
		SISname2.caption=OpenDialog.filename
		FileRead
end sub

sub ExtractButtonClicked
	Extract = 1
	ExtractButton.enabled = 0
	UpdateGUI
	Extract = 0
	OpenFolderButton.enabled = 1
end sub


sub ExtractFile
	dim AddString as string
	dim PreString as string
	dim tempfile as qfilestream
	dim tempsize as string
'	dim extension as string
	dim tempfilename as string ' DEBUG: serve???

	conta_saved=conta_saved +1
	if Extract = 1 then
		Extracted = 1 ' Used in RunFile
		if FileExists(SAVEDIR+AppName) = 0 then
			mkdir(SAVEDIR+AppName)
		end if
	end if
	SISFile.seek(PointFiles+28+4*(CurrentLang-1)*FileRecordType,0)
	SISfile.read(L)
                              if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Lunghezza del file (in "+str$(PointFiles+28)+"-"+hex$(PointFiles+28)+") = "+str$(L))
	ExtractedFileLength = L
	SISFile.seek(PointFiles+28+4*NumLang+4*(CurrentLang-1)*FileRecordType,0)
	SISfile.read(L)
	ExtractedFilePointer = L
	SISFile.seek(PointFiles+28+8*NumLang+4*(CurrentLang-1)*FileRecordType,0)
	SISfile.read(L)
	OriginalFileSize = L
                              if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Inizio file (in "+str$(PointFiles+28+4*CurrentLang+4*(NumLang-1))+"-"+hex$(PointFiles+28+4*CurrentLang+4*(NumLang-1))+") = "+str$(ExtractedFilePointer))
	if SLASH = "\"  then ' Windows
		extension = ""
	else
		extension = ".gz"
	end if
  if Extract = 1 then
  	' Open file to save data into; name contains full path (# in place of \) and language description.
  	' ".gz" extension is added if Linux OS detected.
		TempFileName = SetupFileName()
		ExtractedFile.Open(SAVEDIR+AppName+SLASH+TempFileName, fmCreate)
		SavedFile(conta_saved)= TempFileName
	end if
	SISFile.seek(ExtractedFilePointer,0)

			if NumLang = 1 then
				if compressed = 0 then
					AddString = " - (size = "+strF$(ExtractedFileLength,ffNumber,8,0)+")"
			  end if
			PreString = ""
			if FileTypeAlt = 0 then 'standard
				AddString = AddString + ""
			elseif FileTypeAlt = 1 then
				AddString = AddString + " - (shown)"
			elseif FileTypeAlt = 2 then
      	AddString = AddString + " - (SIS Component)"
			elseif FileTypeAlt = 3 then
      	AddString = AddString + " - (to be run)"
			elseif FileTypeAlt = 4 then
				AddString = AddString + " - (created)"
			end if
 		else
 			PreString = "   " ' Indent multilanguage files.
      AddString =" - (multilanguage)"
	  end if

	if Compressed = 0 then
	 if NumLang>1 then ' If multiple language file, write file number, then indent files.
	 		if CurrentLang=1 then
			 	FilesList.additems(str$(conta+1)+") ") ' Write only file number.
			end if
			' sub-file number before filename:
	 		FilesList.additems(PreString+str$(CurrentLang)+") ("+left$(lingua(CurrentLang),2)+") "+ExtractedFileNameFull+AddString)
	 else
	 		FilesList.additems(str$(conta+1)+") "+ExtractedFileNameFull+AddString)
	 end if
	 if Extract = 1 then
			ExtractedFile.CopyFrom(SISFile, ExtractedFileLength)
			ExtractedFile.close
	 end if
	else ' if file is ZLIB compressed...
                               if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Start uncompression...")
	  CompressedString = SISFile.readbinstr(ExtractedFileLength) ' Store into a string the compressed file;
                               if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Stream read ("+str$(ExtractedFileLength)+" characters; string length="+str$(len(CompressedString))+").")
		ToBeCompressedString_Size = OriginalFileSize ' Setup uncompression buffer
		CompressedBuffer_Size = ExtractedFileLength
                               if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Original file size: "+strF$(OriginalFileSize,ffNumber,8,0))
		sUncompressedString = space$(OriginalFileSize)
		UncompressResult = uncompress(sUncompressedString, ToBeCompressedString_Size, CompressedString, CompressedBuffer_Size)
                               if LogFileCheckbox.checked=1 then LogFile.WriteLine("Uncompression result = "+ ZLib(UncompressResult+7))
		if UnCompressResult = 0 then
			if extract = 1 then
				if SLASH = "\"  then ' Windows
					ExtractedFile.writebinstr(sUncompressedString,OriginalFileSize) ' Save decompressed stream
					ExtractedFile.close
				else	' Linux
					tempfile.open(progdir$+SLASH+"temp"+ExtractedFileName+".bin",fmCreate)
					tempfile.writebinstr(CompressedString,CompressedBuffer_Size) ' Save compressed stream to temporary file
					tempfile.close
 				  ' Write gzip header to file (1f 8b 08 00 00 00 00 00 00 0b):
					ExtractedFile.writebinstr(gzip_header,10)
 				  ' Append compressed stream without first two bytes (which are just ZLIB stream flags):
 				  ExtractedFile.writebinstr(right$(CompressedString,CompressedBuffer_Size-2),CompressedBuffer_Size)
 				  ' append fake crc32 string to stream (00 00 00 00):
 				  ExtractedFile.writebinstr(chr$(0)+chr$(0)+chr$(0)+chr$(0),4)
 				  ' Append original file length to stream:
 				  tempsize = chr$(val(mid$(hex$(ToBeCompressedString_Size),7,2)))
 				  tempsize = tempsize + chr$(val(mid$(hex$(ToBeCompressedString_Size),5,2)))
 				  tempsize = tempsize + chr$(val(mid$(hex$(ToBeCompressedString_Size),3,2)))
 				  tempsize = tempsize + chr$(val(mid$(hex$(ToBeCompressedString_Size),1,2)))
 				  ExtractedFile.writebinstr(tempsize,4)
					ExtractedFile.close
				end if
			end if
		else
                                if LogFileCheckbox.checked=1 then LogFile.WriteLine("Uncompression error!")
		end if
				if compressed = 1 then
					AddString = " - (size = "+strF$(ToBeCompressedString_Size,ffNumber,8,0)+")"
			  end if
	 if NumLang>1 then ' If multiple language file, write file number, then indent files.
	 		if CurrentLang=1 then
			 	FilesList.additems(str$(conta+1)+") (multilanguage)") ' Write only file number.
			end if
			' sub-file number before filename:
	 		FilesList.additems(PreString+str$(CurrentLang)+") ("+left$(lingua(CurrentLang),2)+") "+ExtractedFileNameFull+AddString)
	 else
	 		FilesList.additems(str$(conta+1)+") "+ExtractedFileNameFull+AddString)
	 end if
	 end if
end sub

 sub ChooseSISFile
 		LogFile.Open(curdir$+SLASH+"SISlog.txt",fmCreate)
 		OpenDialog.InitialDir = DEBUGPATH2
 		OpenDialog.Caption = "Select SIS file to open"
		OpenDialog.Filter = "SIS files|*.sis|All Files 	|*.*"
 		if OpenDialog.Execute then
 			FakeFiles = 0 ' Line containing options/if/else,..., must be subtracted to total files number.
 			Extracted = 0 ' Flag used in RunFile proc: if = 0, cannot display file (must be extracted).
		  UpdateGUI
		  OpenFolderButton.enabled = 0
		  ExtractButton.enabled = 1
 	  else
 	    showmessage("No files opened")
 	  end if
 	 LogFile.close
 end sub

 sub FileRead
 			Init ' Initialize all variables
 			ExtractButton.enabled=0
		  SISFilename = OpenDialog.filename
		  if SISFileName = "" then
		  	showmessage("No files loaded!")
		  	exit sub
		  end if
		  ' Read SIS file version.
 			SISFile.Open(SISFilename, fmOpenRead)
 			SISFile.seek(uid2,0)
			SISfile.read(L)
'                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("Il file '" + SISFilename + "' e' di tipo:")
			if hex$(L)="1000006D" then
                                if LogFileCheckbox.checked=1 then LogFile.Write "Epoc Release 5"
				SISVersion = 5
				SISVersionLabel2.caption = "Epoc Release 5"
			end if
			if hex$(l)="10003A12" then
                                if LogFileCheckbox.checked=1 then LogFile.Write "Epoc6/Symbian"
				SISVersion = 6
				SISVersionLabel2.caption = "Epoc6/Symbian"
			end if
   			SISFile.seek(Requisites_pointer,0)
				SISfile.read(L)
				PointCapab = L
   			SISFile.seek(PointCapab,0)
				SISfile.read(L)
				ModelUID = L
   			SISFile.seek(PointCapab+4,0)
				SISfile.read(L)
				Value = L
				conta = 0
				trovato = 0
				while conta<NUM_MODELS and trovato=0 ' Print model type (if known).
					conta = conta+1
					if ucase$(hex$(ModelUID))=ucase$(Model(conta,2)) then
						trovato = 1
						DeviceLabel2.caption = Model(conta,1) & "   (ProductID = 0x" & hex$(ModelUID) & ")"
				else
																			if LogFileCheckbox.checked=1 then LogFile.WriteLine " - Unknown model '"+hex$(ModelUID)+"'"
					DeviceLabel2.caption = "Unknown model (ProductID = 0x" & hex$(ModelUID) & ")"
				end if
				wend
'	                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("      Value = "+str$(L)	+ " (hex="+hex$(L)+")")
			' Get Application UID.
 			SISFile.seek(uid1,0)
			SISfile.read(L)
                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("UID applicazione: "+hex$(L))
			AppUIDLabel2.caption= "0x" & hex$(L)
 			SISFile.seek(options2,0)
			SISfile.read(B)
                                      if LogFileCheckbox.checked = 1 then			LogFile.WriteLine( "Opzioni file SIS: "+ str$(B))
                                      if LogFileCheckbox.checked = 1 then			LogFile.WriteLine( "     1) "+ OptionType(B and 1))
                                      if LogFileCheckbox.checked = 1 then			LogFile.WriteLine( "     2) "+ OptionType(B and 2))
                                      if LogFileCheckbox.checked = 1 then			LogFile.WriteLine( "     3) "+ OptionType(B and 8))
                                      if LogFileCheckbox.checked = 1 then			LogFile.WriteLine( "     4) "+ OptionType(B and 16))
		  	if (B and 8) <> 0  and (SISVersion = 6)  then ' bit 3 is set in ER6 version if file is NOT compressed.
							Compressed = 0
				                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Il file SIS  NON compresso.")
				end if
		  	if (B and 8) = 0  and (SISVersion = 6)  then
							Compressed = 1
				                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Il file SIS  compresso con algoritmo ZLIB.")
				end if
		  	if SISVersion <> 6  then
							Compressed = 0
				                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Il file SIS  NON compresso.")
				end if
			SISFile.seek(languages,0)
			SISfile.read(B)
			NumLang = B
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Lingue supportate: "+str$(B))
 			SISFile.seek(Languages_pointer,0)
			SISfile.read(L)
			PointLang = L
'                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("   Inizio record lingue: "+str$(L)+" (hex="+hex$(L)+")")

' Read application name; it may be different for each language, so it should cycle trhough
' all languages, but you can comment out the FOR cycle to speed up.
			conta = 0
			for x = PointLang to PointLang + 2*(NumLang-1) step 2
			  conta = conta +1 ' Only needed if FOR-NEXT is UNcommented.
 				SISFile.seek(x,0)
				SISfile.read(B)
											                if LogFileCheckbox.checked=1 then LogFile.Write("    Lingua "+str$(conta)+": "+str$(B)+" ("+lingua(B)+")")
 				SISFile.seek(Component_name_pointer,0)
				SISfile.read(L)
				ComponentNameBeginning = L
 				SISFile.seek(ComponentNameBeginning+4*(conta-1),0)
				SISfile.read(L)
				AppNameLength = L
 				SISFile.seek(ComponentNameBeginning+4*NumLang+4*(conta-1),0)
				SISfile.read(L)
				AppNamePointer= L
 				SISFile.seek(AppNamePointer,0)
 				AppName = replacesubstr$(SISfile.readstr(AppNameLength),chr$(0),"")
 				appname=left$(appname,len(appname)-1) ' cut final space.
	                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine(" - Nome = '"+ AppName +"'")
				AppNameLabel2.caption = AppName
			next

 			SISFile.seek(files,0)
			SISfile.read(B)
			NumFiles = B ' Read total number of files (actually, number of lines in original .PKG file) in SIS file.
                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("Files totali: "+str$(B))
 			SISFile.seek(Files_pointer,0)
			SISfile.read(L)
			PointFiles=L ' Pointer to files record.
		'	                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("  Inizio record files: "+str$(L)+ " (hex="+hex$(L)+")")
	conta_saved = 0
	for conta = 0 to NumFiles	- 1
 				 SISFile.seek(PointFiles,0)
				 SISfile.read(L)
				 FileRecordType = L
                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("")
                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine(" ======= File "+str$(conta+1)+"/"+str$(NumFiles)+" ========= ")
                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("   Tipo RECORD: "+str$(L)+ " ("+RecordType(L)+")")
				 RecLen = 0
				 if L = 0 then LocalNumLang = 1 else LocalNumLang = NumLang
				 if SISVersion = 6 then
				 	RecLen = 36 + 12 * LocalNumLang
				 else
				 	RecLen = 28 + 8 * LocalNumLang
				 end if
      if FileRecordType=0 or FileRecordType=1 then 'If SIMPLE FILE LINE or MULTIPLE LANGUAGES FILE LINE...
 			   		SISFile.seek(PointFiles+4,0)
			   		SISfile.read(L)
				 		FileTypeAlt = L
			   		if FileTypeAlt = 0 then ' Standard file (Type FF).
			   		                           if LogFileCheckbox.checked = 1 then LogFile.WriteLine("      Tipo file: "+str$(FileTypeAlt)+ " ("+FileType(FileTypeAlt+1)+")")
							GetFileName
							if FileRecordType = 1 then ' Multilanguage file.
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Estraggo file multilingua")
							  	for CurrentLang = 1 to NumLang
										ExtractFile
								  next
							else ' Single language file.
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Estraggo file singolo")
								CurrentLang = 1
									temp=NumLang
									NumLang=1 'Used in ExtractFile
                	ExtractFile
									NumLang = temp
							end if
			   		elseif  FileTypeAlt = 4	then' File created after running (Type FN)
			   		                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("      Tipo file: "+str$(FileTypeAlt)+ " ("+FileType(FileTypeAlt+1)+")")
						GetFileName
			   		FilesList.Additems(str$(conta+1)+") "+ExtractedFileNameFull+" (created after running)")
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Nome = '"+ ExtractedFileName +"'")
						elseif FileTypeAlt = 1 or FileTypeAlt = 2 or FileTypeAlt = 3 then	 ' File shown during installation or SIS component or ToBeRun.
			   		                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("      Tipo file: "+str$(FileTypeAlt)+ " ("+FileType(FileTypeAlt+1)+")")
						 SISFile.seek(PointFiles+12,0)
			   			SISfile.read(L)
			   			NameLength = L
 			   			SISFile.seek(PointFiles+16,0)
			   			SISfile.read(L)
 			   			SISFile.seek(L,0)
 			   			ExtractedFileNameFull = replacesubstr$(SISfile.readstr(NameLength),chr$(0),"")
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      Nome = '"+ ExtractedFileName +"'")
 			   			ExtractedFileName = mid$(ExtractedFileNameFull,RInstr(ExtractedFileNameFull,SLASH)+1,len(ExtractedFileNameFull)-RInstr(ExtractedFileNameFull,SLASH))
							if FileRecordType = 1 then ' Extract multilanguage files.
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Estraggo file multilingua")
							  for CurrentLang = 1 to NumLang
									ExtractFile
							  next
							else ' Extract single language file.
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Estraggo file singolo")
									CurrentLang = 1
										 temp=NumLang
										 NumLang=1 'Used in ExtractFile
										 ExtractFile
										 NumLang = temp
							end if
						else
							print conta+1,") tipo file ignoto???(",FileTypeAlt,")"
   			 	  end if ' (FileType)
   			 else ' FileRecordType
					' do nothing if file record does not contain actual file (FileRecordType = 0 or 1)
       	 end if

       	 ' ********* /---- Update pointers ----\ ********
				 if FileRecordType = 0  then
						PointFiles = PointFiles + 28 + 8
						if SISversion = 6 then
							PointFiles = PointFiles + 4 + 8
						end if
				 elseif FileRecordType = 1  then
				 		                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      MULTILANGUAGE")
						PointFiles = PointFiles + 28 + 8*NumLang
						if SISversion = 6 then
							PointFiles = PointFiles + 4*NumLang + 8
						end if
				 elseif FileRecordType = 2  then
						FakeFiles = FakeFiles + 1 ' Line containing options/if/else,..., must be subtracted to total files number.
			   		FilesList.additems(str$(conta)+") (config line)")
				 		                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      OPTIONS - OFFSET ERROR? (To be fixed?)")
 						SISFile.seek(PointFiles+4,0)
						SISfile.read(L)
						PointFiles = PointFiles + 8 + 8*NumLang*L + 16 ' ********* CHECK!!!!
				 elseif FileRecordType = 3 or FileRecordType = 4 then
			   		FilesList.additems(str$(conta)+") (config line)")
						FakeFiles = FakeFiles + 1 ' Line containing options/if/else,..., must be subtracted to total files number.
 				 		SISFile.seek(PointFiles+4,0)
				 		SISfile.read(L)
						PointFiles = PointFiles + 8 + L
'				 		                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      IF/ELSEIF, incremento = "+str$(8+L))
				 elseif FileRecordType = 5 or FileRecordType = 6 then
			   		FilesList.additems(str$(conta)+") (config line)")
						FakeFiles = FakeFiles + 1 ' Line containing options/if/else,..., must be subtracted to total files number.
				 		PointFiles = PointFiles + 4
'				 		                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("      ELSE/ENDIF")
				 else
				 		                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("TIPO DI RECORD SCONOSCIUTO???")
				 end if
				 ' ********* \--- Pointers updated ---/ ******
			 '                                      if LogFileCheckbox.checked = 1 then LogFile.WriteLine("Inizio successivo record file: "+str$(PointFiles)+"("+hex$(PointFiles)+")")
    next
		SISFile.seek(requisites,0)
			SISfile.read(B)
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Requisiti: "+str$(B))
 			SISFile.seek(Requisites_pointer,0)
			SISfile.read(L)
'                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("  Inizio record requisiti: "+str$(L)+ " ("+FileType(L+1)+")")
 			SISFile.seek(Installation_drive,0)
			SISfile.read(B)
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Drive di installazione: "+chr$(B))
 			SISFile.seek(Installer_version,0)
			SISfile.read(L)
                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("Versione installer richiesta: "+ str$(L))
			if L = 200 then
	                                      if LogFileCheckbox.checked=1 then LogFile.WriteLine("   (Epoc6/Symbian)")
			end if
			if L = 68 or L = 100 then
																			if LogFileCheckbox.checked=1 then LogFile.WriteLine( "   (Epoc Release 5)")
			end if

 			SISFile.seek(type2,0)
			SISfile.read(B)
																			if LogFileCheckbox.checked=1 then LogFile.WriteLine( "Tipo di file SIS: "+ str$(B)+ " - " + SISType(B+1))

 			SISFile.seek(Major_version,0)
			SISfile.read(B)
			AppVerLabel2.caption = str$(B)
																			if LogFileCheckbox.checked=1 then 			LogFile.Write( "Versione: "+str$(B)+".")

 			SISFile.seek(Minor_version,0)
			SISfile.read(B)
			AppVerLabel2.caption = AppVerLabel2.caption +"."+ zero$(str$(B))
																			if LogFileCheckbox.checked=1 then 			LogFile.WriteLine(str$(B))

			if SISversion = 6 then
 				SISFile.seek(Maximum_installed_space,0)
				SISfile.read(L)
																			if LogFileCheckbox.checked=1 then 				LogFile.WriteLine( "Massimo spazio occupato:"+str$(L))
		  end if
			FilesListLabel.caption = "Files list (" & str$(NumFiles-FakeFiles) & " total)"
 	 if Extract = 1 then showmessage("Done. Files have been saved in folder "+SAVEDIR+AppName)
 	 SISFile.close
 end sub

sub ShowHelp
dim msg as string
dim cr as string
cr = chr$(13)+chr$(10)
	msg="SISRead - View and extract files from SIS Epoc/Symbian archives" & CR
	msg = msg & "Freeware by Luca Cassioli 2005" & CR & CR
	msg = msg & "Select any SIS file (also EPOC ER5 file supported) to view its" &  CR
	msg = msg & "contents. Click on EXTRACT FILES button to extract ALL files:" & CR
	msg = msg & "they will be stored into a subfolder of the folder where the" & CR
	msg = msg & "program is installed; the subfolder is named as the application" & CR
	msg = msg & "contained into SIS file." & CR & CR
	msg = msg & "Windows users:" & CR
	msg = msg & "After extracting files, you can double click on each one of them" & CR
	msg = msg & "to display it (if its type is registered into your Operating System)." & CR & CR
	msg = msg & "For Linux users, files will be stored with extension .GZ, and they'll"& CR
	msg = msg & "have to be extracted manually using GZIP or similar programs." & CR
	msg = msg &  CR &  CR
	msg = msg & "This programs uses ZLIB opensource library: http://www.gzip.org/zlib/" & CR



	showmessage (msg)
end sub
